int sAddBonus(clsScriptContext* pContext, unsigned char* script)
{
	int ArgOld = pContext->ArgCount;
	int progress = ParseScript(pContext, script, 1);
	char* pTemp;

	if (pContext->ArgCount > ArgOld + 3)
	{
		pTemp = (char*) pContext->Args[ArgOld + 3].val;
	}
	else
	{
		pTemp = pContext->scriptName;
	}
	AddBonus(pContext->pCurChar, (int*) pContext->Args[ArgOld].val, pContext->Args[ArgOld + 1].val, pContext->Args[ArgOld + 2].val, pTemp);

	pContext->ArgCount = ArgOld;
	return(progress);
}

int PsiDC(clsScriptContext* pContext, unsigned char* script)
{
	int progress;
	int ArgOld;
	int Disciple;
	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	if (pContext->nCurFeat != -1)
	{
		Disciple = pContext->pCurChar->FeatDependancy[pContext->nCurFeat];
	}
	else
	{
		breakpoint("PsiDC");
	}

	pContext->pCurChar->DiscipleDC[Disciple] += pContext->Args[ArgOld].val;

	pContext->ArgCount = ArgOld;
	return(progress);
}

int SpellDC_a(clsScriptContext* pContext, unsigned char* script)
{
	int progress;
	int ArgOld;
	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	pContext->pCurChar->SchoolDC[pContext->Args[ArgOld].val] += pContext->Args[ArgOld + 1].val;

	pContext->ArgCount = ArgOld;
	return(progress);
}

int SpellDC_b(clsScriptContext* pContext, unsigned char* script)
{
	int progress;
	int ArgOld;
	int School;
	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	if (pContext->nCurFeat != -1)
	{
		School = pContext->pCurChar->FeatDependancy[pContext->nCurFeat];
	}
	else if (pContext->pCurChar->Specialised)
	{
		School = pContext->pCurChar->School;
	}
	else
	{
		breakpoint("SpellDC_b");
	}

	pContext->pCurChar->SchoolDC[School] += pContext->Args[ArgOld].val;

	pContext->ArgCount = ArgOld;
	return(progress);
}

inline int AppendText(clsScriptContext* pContext, unsigned char* script, int NewLine)
{
	int i;

	char AppendText_tmpchar[12];
	int progress;
	int ArgOld;
	if (DebugOutput) {printf(" Appending Text:");}

	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	for (i = ArgOld;i < pContext->ArgCount;i++)
	{
		if (pContext->Args[i].type == 0)
		{
			sprintf(AppendText_tmpchar, "%d", pContext->Args[i].val);
			*pContext->pCurText += AppendText_tmpchar;
		}
		else if (pContext->Args[i].type == 1)
		{
			*pContext->pCurText += (char*) (pContext->Args[i].val);
		}
	}

	if (NewLine)
	{
		*pContext->pCurText += "\n";
	}

	pContext->ArgCount = ArgOld;
	return(progress);
}

int AppendText_a(clsScriptContext* pContext, unsigned char* script)
{
	return(AppendText(pContext, script, 0));
}

int AppendText_b(clsScriptContext* pContext, unsigned char* script)
{
	return(AppendText(pContext, script, 1));
}

int sAddFeatD(clsScriptContext* pContext, unsigned char* script)
{
	int progress, ArgOld;
	int i;

	int* featsyet;
	if (pContext->pCurChar->sAddfeatsyet == 0)
	{
		featsyet = &pContext->pCurChar->FeatCount;
	}
	else
	{
		featsyet = pContext->pCurChar->sAddfeatsyet;
	}

	ArgOld = pContext->ArgCount;

	progress = ParseScript(pContext, script, 1);

	for (i = 0;i < pContext->pCurChar->FeatCount;i++)
	{
		if (pContext->pCurChar->Feats[i] == pContext->Args[ArgOld + 1].val)
		{
			AddFeat(pContext->pCurChar, (int) pContext->Args[ArgOld].val, featsyet, pContext->pCurChar->FeatDependancy[i]);
		}
	}

	pContext->ArgCount = ArgOld;
	return(progress);
}

inline int sAddFeat(clsScriptContext* pContext, unsigned char* script, int dep = 0)
{
	int progress, ArgOld;
	int nFeat, nDep;
	int i;
	int* featsyet;

	if (pContext->pCurChar->sAddfeatsyet == 0)
	{
		featsyet = &pContext->pCurChar->FeatCount;
	}
	else
	{
		featsyet = pContext->pCurChar->sAddfeatsyet;
	}

	if (DebugOutput) {printf(" Adding feat:");}

	ArgOld = pContext->ArgCount;

	progress = ParseScript(pContext, script, 1);

	nFeat = pContext->Args[ArgOld].val;

	if (dep == 0)
	{
		nDep = -2;
		AddFeat(pContext->pCurChar, nFeat, featsyet, nDep);
	}
	else
	{
		for (i = ArgOld + 1;i < pContext->ArgCount;i++)
		{
			if (pContext->Args[i].type == 0)
			{
				nDep = pContext->Args[i].val;
			}
			else if (pContext->Args[i].type == 1)
			{
				if (Source.FeatSource[nFeat].DepType == DEP_WEAPON)
				{
					nDep = GetEquipNumber((char*) pContext->Args[i].val);
				}
				else if (Source.FeatSource[nFeat].DepType == DEP_SPELL)
				{
					nDep = GetSpellNumber((char*) pContext->Args[i].val);
				}
				else if (Source.FeatSource[nFeat].DepType == DEP_SKILL)
				{
					nDep = GetSkillNumber((char*) pContext->Args[i].val);
				}
				else
				{
					printf("Scripting Error\nFeat doesnt match for dependancy: %s\n", Source.FeatSource[nFeat].Name.buffer);
					quitprog();
				}
			}
			else
			{
				printf("Scripting Error\nInvalid Argument for Feat: %s\n",  Source.FeatSource[nFeat].Name.buffer);
				quitprog();
			}

			AddFeat(pContext->pCurChar, nFeat, featsyet, nDep);
		}
	}

	pContext->ArgCount = ArgOld;
	return(progress);
}

int sAddFeat_a(clsScriptContext* pContext, unsigned char* script)
{
	return(sAddFeat(pContext, script, 1));
}

int sAddFeat_b(clsScriptContext* pContext, unsigned char* script)
{
	return(sAddFeat(pContext, script, 0));
}

int sFeatPresent(clsScriptContext* pContext, unsigned char* script)
{
	int progress, ArgOld;
	int retval;

	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	retval = FeatPresent(pContext->pCurChar, pContext->Args[ArgOld].val, pContext->pCurChar->FeatCount);

	pContext->ArgCount = ArgOld;
	pContext->Args[pContext->ArgCount].type = 0;
	pContext->Args[pContext->ArgCount].val = retval;
	pContext->ArgCount++;

	return(progress);
}

int sIsRace(clsScriptContext* pContext, unsigned char* script)
{
	int progress, ArgOld;
	int retval;

	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	retval = (pContext->pCurChar->Race == pContext->Args[ArgOld].val);

	pContext->ArgCount = ArgOld;
	pContext->Args[pContext->ArgCount].type = 0;
	pContext->Args[pContext->ArgCount].val = retval;
	pContext->ArgCount++;

	return(progress);
}

int sIsClass(clsScriptContext* pContext, unsigned char* script)
{
	int progress, ArgOld;
	int retval = 0, nClass;
	int i;

	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	nClass = pContext->Args[ArgOld].val;

	for (i = 0;i < pContext->pCurChar->ClassCount;i++)
	{
		if (pContext->pCurChar->Classes[i] = nClass)
		{
			retval = 1;
			break;
		}
	}

	pContext->ArgCount = ArgOld;
	pContext->Args[pContext->ArgCount].type = 0;
	pContext->Args[pContext->ArgCount].val = retval;
	pContext->ArgCount++;

	return(progress);
}

void BoostSkillA(clsChar* TargetStruct, int nSkill, int nLevel, int Rank = 0, int Bonus = -1, char* Text = EmptyString)
{
	int i;
	bool SkillFound = false;

	for (i = 0;i < TargetStruct->SkillCount;i++)
	{
		if (TargetStruct->Skills[i] == nSkill)
		{
			if (Rank)
			{
				TargetStruct->SkillRank[i] += nLevel;
			}
			else
			{
				if (Bonus != -1)
				{
					AddBonus(TargetStruct, &TargetStruct->SkillBonus[i], nLevel, Bonus, Text);
				}
				else
				{
					TargetStruct->SkillBonus[i] += nLevel;
				}
			}
			SkillFound = true;
			break;
		}
	}

	if (!SkillFound)
	{
		TargetStruct->Skills[TargetStruct->SkillCount] = nSkill;
		if (Rank)
		{
			TargetStruct->SkillRank[TargetStruct->SkillCount] = nLevel;
		}
		else
		{
			if (Bonus != -1)
			{
				AddBonus(TargetStruct, &TargetStruct->SkillBonus[TargetStruct->SkillCount], nLevel, Bonus, Text);
			}
			else
			{
				TargetStruct->SkillBonus[TargetStruct->SkillCount] = nLevel;
			}
		}
		TargetStruct->SkillCount++;
	}
}

inline int BoostSkill(clsScriptContext* pContext, unsigned char* script, int FeatDep = 0, int Rank = 0, int Bonus = 0)
{
	int progress, ArgOld;

	int nSkill, nLevel, nBonus = -1;

	if (DebugOutput) {printf(" Boosting Skill:");}

	ArgOld = pContext->ArgCount;

	progress = ParseScript(pContext, script, 1);
	
	if (FeatDep)
	{
		nSkill = pContext->pCurChar->FeatDependancy[pContext->nCurFeat];
		nLevel = pContext->Args[ArgOld].val;
		if (Bonus)
		{
			nBonus = pContext->Args[ArgOld + 1].val;
		}
	}
	else
	{
		nSkill = pContext->Args[ArgOld].val;
		nLevel = pContext->Args[ArgOld + 1].val;
		if (Bonus)
		{
			nBonus = pContext->Args[ArgOld + 2].val;
		}
	}

	BoostSkillA(pContext->pCurChar, nSkill, nLevel, Rank, nBonus, pContext->scriptName);

	pContext->ArgCount = ArgOld;
	return(progress);
}

int BoostSkill_a(clsScriptContext* pContext, unsigned char* script)
{
	return(BoostSkill(pContext, script));
}

int BoostSkill_b(clsScriptContext* pContext, unsigned char* script)
{
	return(BoostSkill(pContext, script, 1));
}

int BoostSkill_c(clsScriptContext* pContext, unsigned char* script)
{
	return(BoostSkill(pContext, script, 1, 1));
}

int BoostSkill_d(clsScriptContext* pContext, unsigned char* script)
{
	return(BoostSkill(pContext, script, 1, 0, 1));
}

int BoostSkill_e(clsScriptContext* pContext, unsigned char* script)
{
	return(BoostSkill(pContext, script, 0, 0, 1));
}

int GetSkillLevel(clsScriptContext* pContext, unsigned char* script)
{
	int ArgOld, progress;
	int nSkill;
	int retval;
	int i;

	if (DebugOutput) {printf(" Catching Skill Level:");}
	ArgOld = pContext->ArgCount;

	progress = ParseScript(pContext, script, 1);
	nSkill = pContext->Args[ArgOld].val;

	pContext->ArgCount = ArgOld;

	retval = 0;
	for (i = 0;i < pContext->pCurChar->SkillCount;i++)
	{
		if (pContext->pCurChar->Skills[i] == nSkill)
		{
			retval = pContext->pCurChar->SkillRank[i];
			break;
		}
	}

	pContext->Args[pContext->ArgCount].type = 0;
	pContext->Args[pContext->ArgCount].val = retval;
	pContext->ArgCount++;

	return(progress);
}

int GetArmorType(clsScriptContext* pContext, unsigned char* script)
{
	int MaxArmor = -1;
	int i;

	for (i = 0;i < pContext->pCurChar->EquipCount;i++)
	{
		if (pContext->pCurChar->Equipment[i].EquipType == EQUIP_ARMOR && pContext->pCurChar->Equipment[i].Type > MaxArmor)
		{
			MaxArmor = pContext->pCurChar->Equipment[i].Type;
		}
	}

	pContext->Args[pContext->ArgCount].type = 0;
	pContext->Args[pContext->ArgCount].val = MaxArmor;
	pContext->ArgCount++;

	return(ParseScript(pContext, script, 1));
}

int sRandom(clsScriptContext* pContext, unsigned char* script)
{
	int progress, ArgOld;

	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	pContext->Args[ArgOld].val = random(pContext->pCurChar->Context.seeda, pContext->Args[ArgOld].val, pContext->Args[ArgOld + 1].val, "Random by script");
	pContext->ArgCount = ArgOld + 1;

	return(progress);
}

int sEnhence(clsScriptContext* pContext, unsigned char* script)
{
	int progress, ArgOld;

	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	pContext->Args[ArgOld].val = Enhence(pContext->pCurChar->Context.seeda, pContext->Args[ArgOld].val);

	return(progress);
}

int SubText(clsScriptContext* pContext, unsigned char* script)
{
	pContext->pCurText = pContext->pCurSubText;
	return(ParseScript(pContext, script, 1));
}

int MainText(clsScriptContext* pContext, unsigned char* script)
{
	pContext->pCurText = pContext->pCurMainText;
	return(ParseScript(pContext, script, 1));
}

int sGetElement(clsScriptContext* pContext, unsigned char* script)
{
	int ArgOld, progress;
	int Num;

	ArgOld = pContext->ArgCount;

	progress = ParseScript(pContext, script, 1);

	if (pContext->ArgCount == ArgOld)
	{
		Num = -1;
	}
	else
	{
		Num = pContext->Args[ArgOld].val;
	}

	pContext->Args[ArgOld].val = (int) GetElement(pContext->pCurChar->Context.seeda, Num, 1);
	pContext->Args[ArgOld].type = 1;
	pContext->ArgCount = ArgOld + 1;

	return(progress);
}
