int GetValNumber(char** Vals, char* String, int Number, bool Force = true)
{
	int i;
	for (i = 0;i < Number;i++)
	{
		if (stricmp(Vals[i], String) == 0)
		{
			return(i);
		}
	}
	if (Force)
	{
		printf("Value not found: %s\n", String);
		quitprog();
	}
	return(-1);
}

char *buffer;
int buffersize;

int CountSetLines(FILE* fFile)
{
	int Number = 0;
	fseek(fFile, 0, SEEK_SET);
	fgets(buffer, buffersize, fFile);
	fgets(buffer, buffersize, fFile);
	while (!feof(fFile))
	{
		if (fgets(buffer, buffersize, fFile) == NULL)
		{
			break;
		}
		if (buffer[0] != 10 && buffer[0] != 13)
		{
			Number++;
		}
	}
	fseek(fFile, 0, SEEK_SET);
	fgets(buffer, buffersize, fFile);
	fgets(buffer, buffersize, fFile);

	return(Number);
}

char** Vals;

void ProcessLine(FILE *fFile, void (*ProcessFunction)(char* Vals[], void* TargetStruct, void* TempStruct, int Number, bool header), void* TargetStruct, void* TempStruct, bool header)
{
	bool nextval = false;
	unsigned int i, j, k;
	int inQuotes = false;

	static unsigned int valcount;

	do
	{
		fgets(buffer, buffersize, fFile);
	} while (buffer[0] == 10 || buffer[0] == 13);

	Vals[0] = &buffer[0] + (inQuotes = (buffer[0] == '"'));
	j = 1;
	k = strlen(buffer);
	for (i = inQuotes;i < k;i++)
	{
		if (buffer[i] == 10 || buffer[i] == 13)
		{
			buffer[i] = 0;
		}
		else if (inQuotes == 0 && (buffer[i] == 32 || buffer[i] == 9))
		{
			nextval = true;
			buffer[i] = 0;
			if (buffer[i + 1] == '"')
			{
				inQuotes = 1;
				buffer[++i] = 0;
			}
		}
		else if (nextval)
		{
			if (buffer[i] == '"' && inQuotes == 1)
			{
				buffer[i] = 0;
				inQuotes = 0;
			}
			nextval = false;
			Vals[j] = &buffer[i];
			j++;
		}
		else if (buffer[i] == '"' && inQuotes == 1)
		{
			buffer[i] = 0;
			inQuotes = 0;
		}
	}

	if (header)
	{
		valcount = j;
	}
	else if (valcount != j)
	{
		printf("Invalid Number in Database (%d instead of %d)\n", j, valcount);
	}
	
	ProcessFunction(&Vals[0], TargetStruct, TempStruct, j, header);
}

template <class T, class U> int SourceInit(char* FileName, T** Source, U** TempSource, int* SourceCount, void (*ProcessFunction)(char** Vals, void* TargetStruct, void* TempStruct, int Number, bool header), int AddMem = 0, bool NoAlloc = false)
{
	int i;
	FILE* hFile;

	if (DebugOutput) {printf("Opening File (%s)\t", FileName);}
	hFile = fopen(FileName, "r");
	if (hFile == 0)
	{
		printf("FAILED\n");
		return(1);
	}

	fseek(hFile, 0, SEEK_END);
	buffersize = ftell(hFile);
	buffer = (char*) mallocl(buffersize + 1, "SourceInit-buffer");
	Vals = (char**) mallocl(buffersize / 2 * sizeof(char*), "SourceInit-Vals");
	fseek(hFile, 0, SEEK_SET);

	if (DebugOutput) {printf("OK\nReading List\t\t\t");}
	ProcessLine(hFile, ProcessFunction, NULL, NULL, true);
	*SourceCount = CountSetLines(hFile);
	if (DebugOutput) {printf("%d\n", *SourceCount);}

	if (!NoAlloc)
	{
		SetNewIdent("SourceInit-Source");
		*Source = new T[*SourceCount + AddMem];
		if (TempSource)
		{
			*TempSource = new U[*SourceCount + AddMem];
		}
	}
	if (DebugOutput) {printf("\t( ");}

	for (i = 0;i < *SourceCount;i++)
	{
		ProcessLine(hFile, ProcessFunction, (Source == NULL ? NULL : &((*Source)[i])), (TempSource == NULL ? NULL : &((*TempSource)[i])), false);
		if (DebugOutput && Source) {printf("%s ", (*Source)[i].Name.buffer);}
	}
	if (DebugOutput) {printf(")\n");}
	if (DebugOutput) {printf("\n");}

	fclose(hFile);

	freel(buffer);
	freel(Vals);

	return(0);
}

int FillArrayFromFile(char* FileName, int* Target, int MinLen)
{
	FILE* fp;
	int i = 0, j;
	char* buffer;
	int buffersize;
	int temp;

	fp = fopen(FileName, "r");

	fseek(fp, 0, SEEK_END);
	buffersize = ftell(fp);
	buffer = (char*)  mallocl(buffersize + 1, "FillArrayFromBFile-buffer");
	fseek(fp, 0, SEEK_SET);

	while (!feof(fp))
	{
		fgets(buffer, buffersize, fp);
		sscanf(buffer, "%d\t%d\n", &temp, &Target[i]);
		i++;
	}
	for (j = i;j < MinLen;j++)
	{
		Target[j] = Target[i - 1];
	}

	freel(buffer);

	return(0);
}
