#ifdef DUMP_SOURCE
#ifdef CACHE_LINE_ALIGN

int run_check_exception(unsigned int code, struct _EXCEPTION_POINTERS *ep)
{
	unsigned long retTmp;
	static int lastvar = -1, lastpage, dualpage = 0;
	static void* lasteip = NULL;
	int var, thispage;
	if (code == EXCEPTION_GUARD_PAGE)
	{
		thispage = (ep->ExceptionRecord->ExceptionInformation[1] - VIRTUAL_COMPACT_BASE) / dwPageSize;
		var = dwPageMap[thispage];

		if (lasteip && ep->ExceptionRecord->ExceptionAddress == lasteip && var == lastvar)
		{
			if (dualpage)
			{
				retTmp = VirtualProtect((void*) (VIRTUAL_COMPACT_BASE + dualpage * dwPageSize), dwPageSize, PAGE_READWRITE | PAGE_GUARD, &retTmp);
			}
			dualpage = lastpage;
		}
		else if (lastpage)
		{
			retTmp = VirtualProtect((void*) (VIRTUAL_COMPACT_BASE + lastpage * dwPageSize), dwPageSize, PAGE_READWRITE | PAGE_GUARD, &retTmp);
			if (dualpage)
			{
				retTmp = VirtualProtect((void*) (VIRTUAL_COMPACT_BASE + dualpage * dwPageSize), dwPageSize, PAGE_READWRITE | PAGE_GUARD, &retTmp);
				dualpage = 0;
			}
		}
		lasteip = ep->ExceptionRecord->ExceptionAddress;

		lastpage = thispage;

		if (var != -1 && lastvar != -1 && var != lastvar)
		{
			dwMemAccessCount++;

			if (dwVarAccess[var * dwVarCount + lastvar] == dwMemAccessMax)
			{
				dwMemAccessMax++;
			}

			//printf("Access: %d, Var: %d, Last Var: %d\n", ep->ExceptionRecord->ExceptionInformation[1], var, lastvar);
			dwVarAccess[var * dwVarCount + lastvar]++;
			dwVarAccess[var * dwVarCount + var]++;
		}

		lastvar = var;
		return(EXCEPTION_CONTINUE_EXECUTION);
	}
	else
	{
		return(EXCEPTION_CONTINUE_SEARCH);
	}
}

#endif

inline int run_init_a(int &CompactSize, int &VirtualAllocError, int &oldMallocID, int &oldnTreeSize, int &oldMallocCount)
{
	CompactSourceAllocated = (VirtualAlloc((void*) VIRTUAL_COMPACT_BASE, CompactSize, MEM_RESERVE, PAGE_READWRITE) != NULL);
	if (CompactSourceAllocated)
	{
		if (VirtualAlloc((void*) VIRTUAL_COMPACT_BASE, CompactSize, MEM_COMMIT, PAGE_READWRITE) == NULL)
		{
			VirtualFree((void*) VIRTUAL_COMPACT_BASE, 0, MEM_RELEASE);
		}
		else
		{
			VirtualAllocError = 0;
		}
	}

	if (VirtualAllocError)
	{
		printf("Memmory Allocation Error\n");
		breakpoint("run_init");
	}

	((char*) VIRTUAL_COMPACT_BASE)[0] = 0;
	EmptyString = (char*) VIRTUAL_COMPACT_BASE;

	MallocID = oldMallocID;
	nTreeSizeMax = oldnTreeSize;
	bnf::pTree = 0;
	MallocLogCount = oldMallocCount;

	ReserveHigh = 1;
	if (SourceInit() == 1) {return(1);}
	ReserveHigh = 0;

	return(0);
}

#endif

int run_init()
{
	LARGE_INTEGER init_start, init_end, init_bnfpassed;

	QueryPerformanceCounter(&init_start);
	if (fConsistenceCheck == false)
	{
		printf("Initializing Data...\n");
	}

	if (MustRebuild || TestScript)
	{
#ifdef INCLUDE_REBUILD
		printf("Initializing Script Grammar\n");
		if (bnf::bnfinit())
		{
			printf("Error initialising Script Grammer\n");
			return(1);
		}
#endif
	}

	Source.lpSymbolStart = bnf::SymbolNames;

	if (RedirectSymbols())
	{
		return(1);
	}
	
#ifdef ALLOW_TEST_SCRIPT
	if (TestScript)
	{
		int DebugOld;
		tempoutcommon[0] = 0;

		bnf::SplitFile("Build\\TestScript.scr");
		OptimizeScript2(&bnf::pTree);
		DebugOld = DebugOutput;
		DebugOutput = 1;
		RunScript(&cDumpChar, &eDumpEquip, &tempoutstring, bnf::pTree, "Testscript");
		DebugOutput = DebugOld;

		freel(bnf::pTree);
		bnf::pTree = NULL;
		bnf::bnfreset();

		printf("\n\nText:\n\n%s", tempoutstring);

		return(-1);
	}
#endif

	if (MustRebuild && Rebuilded == 0)
	{
		printf("Initializing Source\n");
#ifdef DUMP_SOURCE_LOAD
		printf("Rebuilding as Dump could not be loaded correctly\n");
#endif

#ifndef INCLUDE_REBUILD
		printf("Cannot Rebuild AS Rebuild Code is not included!\n");
		return(1);
#endif

		QueryPerformanceCounter(&init_bnfpassed);

#ifdef DUMP_SOURCE
		int oldMallocID, oldnTreeSize, oldMallocCount;

		oldMallocID = MallocID;
		oldnTreeSize = nTreeSizeMax;
		oldMallocCount = MallocLogCount;
#endif

#ifdef INCLUDE_REBUILD
		if (SourceInit() == 1) {return(1);}
		printf("Done\n");
#endif

#ifdef DUMP_SOURCE
		int CompactSize;
		
		if (CompactSourceAllocated)
		{
			if (VirtualFree((void*) VIRTUAL_COMPACT_BASE, 0, MEM_RELEASE) == false)
			{
				printf("Could not free Virtual Memmory - Cannot rebuild");
				breakpoint("run_init");
			}
		}
		printf("Rebuilding Compact Source...\n\t");

		CompactSize = PackMallocIDS(oldMallocID);

		int VirtualAllocError = 1;

		SourceExit();
		if (run_init_a(CompactSize, VirtualAllocError, oldMallocID, oldnTreeSize, oldMallocCount))
			return(1);

#ifdef CACHE_LINE_ALIGN
		unsigned long retTmp;
		retTmp = VirtualProtect((void*) VIRTUAL_COMPACT_BASE, CompactSize, PAGE_READWRITE | PAGE_GUARD, &retTmp);
		printf("\nDoing Runtime Analysis...\n");

		clsChar* CDummy = (clsChar*) malloc(sizeof(clsChar));
		CharTemplate* CTDummy = (CharTemplate*) malloc(sizeof(CharTemplate));

		ZeroMemory(CDummy, sizeof(clsChar));
		ZeroMemory(CTDummy, sizeof(CharTemplate));

		CDummy->CreationTemplate = CTDummy;
		CTDummy->MinLevel = 0;
		CTDummy->MaxLevel = 50;
		CTDummy->Monster = -1;
		CTDummy->Mixed = -1;
		CTDummy->MonsterName = -1;
		CTDummy->Race = -1;
		BenchmarkMode = 1;
		isaacinitrand();

		fDropMsg = true;
		__try
		{
			Intel_Create_Char((void*) CDummy);
		} __except (run_check_exception(GetExceptionCode(), GetExceptionInformation())){}
		CDummy->~clsChar();
		CTDummy->~CharTemplate();
		free(CDummy);
		free(CTDummy);
		fDropMsg = false;

		BenchmarkMode = 0;

		retTmp = VirtualProtect((void*) VIRTUAL_COMPACT_BASE, CompactSize, PAGE_READWRITE, &retTmp);

		VirtualFree((void*) VIRTUAL_COMPACT_BASE, 0, MEM_RELEASE);
		CompactSize = RepackMallocIDS();

		printf("Done\n\nReinitializing...\n\t");

		SourceInitDone = false;
		if (run_init_a(CompactSize, VirtualAllocError, oldMallocID, oldnTreeSize, oldMallocCount))
			return(1);

#endif

		ReleaseMallocIDS();
		printf("Done\n");

#endif

		QueryPerformanceCounter(&init_end);

		printf("Init took %d usec\n\n", (int) ((init_end.QuadPart - init_start.QuadPart) * 1000000 / qwFreq));

#ifdef DUMP_SOURCE
#ifndef GCC_RUNTIME
		if (SaveAllocs(CompactSize, init_bnfpassed.QuadPart, init_end.QuadPart, "source.dnd", &Source, sizeof(clsSource), bnf::SymbolNames, SymbolNameSizeCopy, 0))
		{
			printf("Could not Dump Source into File\n");
		}
#else
		printf("Cannot Dump Using GCC Runtime!\n");
#endif
#endif

		Rebuilded = 1;
	}
	else
	{
		if (fConsistenceCheck == false)
		{
			printf("No Source Rebuild required\n");
		}
	}

#ifdef MALLOC_LOG
	if (fConsistenceCheck == false)
	{
		printf("Memmory Allocs after Init: %d\n", MallocLogCount);
	}
#endif

	return(0);
}

int run_worktype()
{
	int i, j, k, l;
	if (worktype == 2)
	{
		ListSpells();
		return(-1);
	}

	if (worktype == 1)
	{
		p<int> mprob;
		
		j = AdvancedRand(isaacseeds[0], Source.MonsterTypeSourceCount, &FixedProb, 0, (char*) &Source.MonsterTypeSource[0].Name.buffer, sizeof(clsMonsterTypeSource), "Typ whlen!", 1, 1);
		mprob = (int*) mallocl(Source.MonsterSourceCount * sizeof(int), "run-mprob");
		for (i = 0;i < Source.MonsterSourceCount;i++)
		{
			if (Source.MonsterSource[i].Type == j)
			{
				mprob[i] = 1;
			}
			else
			{
				mprob[i] = 0;
			}
		}
		l = AdvancedRand(isaacseeds[0], Source.MonsterSourceCount, mprob, sizeof(int), (char*) &Source.MonsterSource[0].Name.buffer, sizeof(clsMonsterSource), "Monster whlen!", 1, 1);

		printf("\n\n\n%s:\n\n", Source.MonsterSource[l].Name.buffer);
		int a, b;
		for (k = 0;k < 11;k++)
		{
			printf("Template: %s\n", Source.TemplateSource[k].Name.buffer);
			for (j = 0;j < 4;j++)
			{
				a = DetermineCR(l, j, k, &b, 0);
				if (a <= 60)
				{
					printf("\tHD Inc: %2d - Possible CRs: %2d - %2d\n", j, a, b);
				}
			}
			printf("\n");
		}

		return(-1);
	}
	return(0);
}

void run_alloc()
{
	int i;
	SetNewIdent("run_alloc-Characters");
	Characters = new clsChar[GT.CharCount];
	SetNewIdent("run_alloc-CT");
	CTs = new CharTemplate[GT.CharCount];
	Screens = (HANDLE*) mallocl((GT.CharCount + 1) * sizeof(HANDLE), "run-Screen");
	SetNewIdent("run_alloc_TempTables");
	FullTables = new string[GT.CharCount];
	if (CTs == 0 || Characters == 0)
	{
		printf("Memmory Allocation Error\n");
		quitprog();
	}

	for (i = 0;i < GT.CharCount;i++)
	{
		Characters[i].CreationTemplate = &CTs[i];
	}
}

void run_cleanup(int cleanup_screans = 1, int free_mem = 1, int finish_up = 1)
{
	int i;
	if (cleanup_screans)
	{
		if (fConsistenceCheck == false)
		{
			SetConsoleActiveScreenBuffer(Screens[0]);
			ClearConsole(0);
		}
		for (i = 1;i <= GT.CharCount;i++)
		{
			CloseHandle(Screens[i]);
		}
	}

	if (free_mem)
	{
		delete[] Characters;
		delete[] CTs;
		delete[] FullTables;
		FullTable.~string();
		freel(Screens);
	}

	if (finish_up)
	{
		FreeRedirectedSymbols();
	}
}

int threadloop = 0;

int run_templates()
{
	int i, j, k;

	GT.CharCount = random(isaacseeds[0], CreatureMin, CreatureMax, "Anzahl eingeben!", 0);

	BaseFrame.AllowEpic = (FullCRMax > 20);

	run_alloc();
	SRs = (int*) mallocl(GT.CharCount * sizeof(int), "run-SR");

	if (GT.CharCount > 1)
	{
		GT.FullCR = random(isaacseeds[0], FullCRMin, FullCRMax, "HG Eingeben!", 0);

		for (i = 0;i < GT.CharCount;i++)
		{
			SRs[i] = GT.FullCR;
			for (j = GT.CharCount;j > 1;j /= 2)
			{
				SRs[i]--;
				if (SRs[i] > 5)
				{
					SRs[i]--;
				}
				if (SRs[i] > 10)
				{
					SRs[i]--;
				}
				SRs[i] = max(0, SRs[i]);
			}
		}

		i = 0;
		j = GT.CharCount - 1;
		while (i < j)
		{
			k = random(isaacseeds[0], 0, GT.FullCR / 5 + 1, "HG Abweichung bei Gegner", 0);
			if (random(isaacseeds[0], 0, 1, "Abweichung umkehren?", 0) == 1)
			{
				k *= -1;
			}
			if (SRs[i] + k < GT.FullCR && SRs[j] - k > 0)
			{
				SRs[i] += k;
				SRs[j] -= k;
			}
			i++;
			j--;
		}
	}


	for (i = 0;i < GT.CharCount;i++)
	{
		CTs[i].AttributePreset = 0;
		if (ChooseClass && (!manual))
		{
			CTs[i].AttributeType = 1;
		}
		else
		{
			CTs[i].AttributeType = -1;
		}
		if (BaseFrame.DrawType == -1)
		{
			CTs[i].AttributeType = 0;
		}
		CTs[i].Class = NULL;
		CTs[i].MinLevel = SRs[i];
		CTs[i].MaxLevel = SRs[i];
		CTs[i].Monster = (CreatureType == -1 ? -1 : min(1, CreatureType) && CreatureType != 4);
		CTs[i].MonsterName = -1;
		CTs[i].Mixed = (CreatureType == 2);
		CTs[i].Treasure = (CreatureType == 3);
		CTs[i].NPCClass = (CreatureType == 4);
		CTs[i].TreasureMax = TreasureMax;
		CTs[i].TreasureMin = TreasureMin;
		CTs[i].Race = -1;
		CTs[i].Life = -100;
		CTs[i].Reproduce = 0;
	}

	if (GT.CharCount == 1)
	{
		CTs[0].MinLevel = FullCRMin;
		CTs[0].MaxLevel = FullCRMax;
		GT.FullCR = -1;
	}

	freel(SRs);

	if (loop && dwThreads > 1 && GT.CharCount == 1)
	{
		CharTemplate tmp;
		CopyMemory(&tmp, CTs, sizeof(CharTemplate));
		ZeroMemory(CTs, sizeof(CharTemplate));

		run_cleanup(0, 1, 0);
		GT.CharCount = dwThreads;
		run_alloc();
		for (i = 0;i < GT.CharCount;i++)
		{
			CopyMemory(&CTs[i], &tmp, sizeof(CharTemplate));
		}
		threadloop = 1;
	}

	return(0);
}

int run_reproduce()
{
	char VCheck[4];
	string fullrepfile = "Save\\";
	char ibuffer[SMALL_BUFFER_LEN];
	int i;

	ZeroMemory(VCheck, 4);

	reproduce = 0;
	readreproduce = 1;
	*prepos = 0;

	if (UseReHeaderSave)
	{
		GT.CharCount = 1;
		run_alloc();
		CopyMemory(Characters[0].CreationTemplate, &ReHeaderSave, sizeof(CharTemplate));
		readreproducefinished = 1;
		UseReHeaderSave = false;
	}
	else
	{
		printf("Gespeicherte Dateien:\n");
		ListDir("save\\*.*");
		printf("\nDateinamen zum reproduzieren eingeben! ");
		fgets(ibuffer, 1023, stdin);
		sscanf(ibuffer, "%s\n", refname);

		fullrepfile += refname;
		str_replace('\\', '-', fullrepfile.buffer + 5);
		reRead = fopen(fullrepfile.buffer, "rb");
		if (reRead == 0)
		{
			printf("Error: File not found: %s\n\tTrying %s.rep\n", refname, refname);
			fullrepfile += ".rep";
			reRead = fopen(fullrepfile.buffer, "rb");
			if (reRead == 0)
			{
				printf("Fatal Error: Could not open File\n");
				return(1);
			}
		}

		fread(VCheck, 4, 1, reRead);
		if (strncmp(VCheck, "DNDR", 4) != 0)
		{
			printf("File is not a DND Reproduce File\nExiting\n");
			return(1);
		}

		fread(&GT, sizeof(GroupTemplate), 1, reRead);
		run_alloc();
		for (i = 0;i < GT.CharCount;i++)
		{
			fread(Characters[i].CreationTemplate, sizeof(CharTemplate), 1, reRead);
			Characters[i].CreationTemplate->Reproduce = 1;
		}
	}

	return(0);
}

int run_screenbuffer()
{
	int i;
	COORD Size;

	CONSOLE_SCREEN_BUFFER_INFO Info;
	GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE), &Info);
	Size.X = (short) max((DWORD) Info.dwMaximumWindowSize.X, (DWORD) 125);
	Size.Y = (short) max((DWORD) Info.dwMaximumWindowSize.Y, (DWORD) 500);

	Screens[0] = GetStdHandle(STD_OUTPUT_HANDLE);
	
	for (i = 1;i <= GT.CharCount;i++)
	{
		Screens[i] = CreateConsoleScreenBuffer(GENERIC_WRITE, 0, NULL, CONSOLE_TEXTMODE_BUFFER, NULL);
		if (fConsistenceCheck == false)
		{
			SetConsoleScreenBufferSize(Screens[i], Size);
		}
		ClearConsole(i);
		if (Screens[i] == INVALID_HANDLE_VALUE)
		{
			printf("Could not create screen buffer\n");
			quitprog(false);
		}
	}

	return(0);
}

int loopcount = 0;
__int64 TotalTime = 1, TotalDisplayTime = 1;
LARGE_INTEGER full_start, full_now;
bool forcethreadexit;
int threadsexited;

struct clsThreadData
{
	int start;
	int end;
	bool primary;
	HANDLE handle;
};

unsigned long __stdcall run_main_do(void* data)
{
	int i, j;

	int start = ((clsThreadData*) data)->start;
	int end = ((clsThreadData*) data)->end;
	bool primary = ((clsThreadData*) data)->primary;

	int finishreadreproduce = readreproduce;

	for (i = start;i < end;i++)
	{
		printf("Generating Char %d (Thread: %d)\n", i, ((clsThreadData*) data)->handle);
		if (primary && fConsistenceCheck == false)
		{
			SetConsoleActiveScreenBuffer(Screens[0]);
		}
		do
		{
#ifndef VECTORC_RUNTIME
xRestartChar_A:
			try
			{
				CreateChar(&Characters[i]);
			}
			catch(xRestartChar)
			{
				*prepos = reposused;
				saverep("", true);
				Characters[i].CreationTemplate->Reproduce = 1;
				readreproducefinished = 1;
				goto xRestartChar_A;
			}
#else
			CreateChar(&Characters[i]);
#endif
			TPLeft[i + 1] = Characters[i].TPLeft;
			if (loopdisplay)
			{
				if (loop)
				{
					DisplayChar(&Characters[i], i + 1);
				}
				ClearConsole(i + 1);
			}

			if ((finishreadreproduce && !fConsistenceCheck) || readreproduce)
			{
				if (readreproducefinished == 0)
				{
					fclose(reRead);
				}
				readreproducefinished = 0;
				readreproduce = 0;
				isaacinitrand();
				IsaacRun = 1;
			}

			loopcount++;
			if (loop)
			{
				QueryPerformanceCounter(&full_now);
				full_now.QuadPart = (__int64) loopcount * qwFreq / (full_now.QuadPart - full_start.QuadPart);
				TotalTime += Characters[i].CreationTime;
				TotalDisplayTime += (__int64) Characters[i].DisplayTime;

				if (primary && loopcount % CONF_DISPLAY_SKIP == 0)
				{
					printf("%d Loop (%d/%3d usec, %d / sec    -    AVG: %d/%3d usec, %d / sec (%d))",
						loopcount,
						(int) Characters[i].CreationTime,
						Characters[i].DisplayTime,
						1000000 / (int) Characters[i].CreationTime,
						(int) (TotalTime / (__int64) loopcount),
						(int) (TotalDisplayTime / (__int64) loopcount),
						(int) (1000000 / (TotalTime / (__int64) loopcount)),
						full_now.LowPart);
					if (Characters[i].Mixed)
					{
						printf(" Dummy: %d", (int) Characters[i].MixedTime);
					}
					printf("\n");
					if (loopcount > 100 && Characters[i].CreationTime > TotalTime / (__int64) loopcount * (__int64) 25)
					{
						printf("\tCreation took unecspected long...\n");
						saverep("long.rep", true, NULL, 1, 1);
					}
				}
				if ((loopcount & 255) == 0)
				{
					SleepEx(0, false);
				}
			}
			if (!primary && forcethreadexit)
			{
				threadsexited++;
				return(0);
			}
			if (primary && loop && kbhit())
			{
				j = getch();
				if (j == 'l')
				{
					ClearConsole(0);
					loop = 0;
					forcethreadexit = true;
				}
				else if (j == 'n')
				{
					loop = 0;
					Restart = 1;
					forcethreadexit = true;
					return(1);
				}
				else if (j == 'r')
				{
					TotalTime = 1;
					TotalDisplayTime = 1;
					QueryPerformanceCounter(&full_start);
					loopcount = 0;
				}
				else if (j == 'q')
				{
					forcethreadexit = true;
					return(1);
				}
			}
			if (loop)
			{
				Characters[i].CreationTemplate->Life = -100;
			}
		}
		while (loop);
		loopdisplay = 0;

		if (primary && fConsistenceCheck == false)
		{
			SetConsoleActiveScreenBuffer(Screens[i + 1]);
		}

		DisplayChar(&Characters[i], i + 1);
	}
	if (!primary)
	{
		threadsexited++;
	}
	return(0);
}

int run_main()
{
	int i, j;

	forcethreadexit = false;
	threadsexited = 0;
	clsThreadData* ThreadData = (clsThreadData*) mallocl(dwThreads * sizeof(clsThreadData), "run_main-threaddata");

	ZeroMemory(ThreadData, dwThreads * sizeof(clsThreadData));

	QueryPerformanceCounter(&full_start);

	if (GT.CharCount && threadloop == 0)
	{
		ThreadData[0].start = 0;
		ThreadData[0].end = 1;
		ThreadData[0].primary = true;
		CopyMemory(&Characters[0].Context, &CharContexts[0], sizeof(clsChar::clsCharContext));

		if ((j = run_main_do(&ThreadData[0])) != 0)
		{
			return(j);
		}
	}

	if (GT.CharCount > 1 || threadloop)
	{
		i = threadloop ^ 1;
		for (j = 0;j < dwThreads;j++)
		{
			ThreadData[j].start = i;
			i = (GT.CharCount - (threadloop ^ 1)) * (j + 1) / dwThreads + (threadloop ^ 1);
			i = min(i, GT.CharCount);
			ThreadData[j].end = i;
			ThreadData[j].primary = (j == 0);
		}
		for (j = 0;j < dwThreads;j++)
		{
			for (i = ThreadData[j].start;i < ThreadData[j].end;i++)
			{
				CopyMemory(&Characters[i].Context, &CharContexts[j], sizeof(clsChar::clsCharContext));
			}
			if (j)
			{
				if ((ThreadData[j].handle = CreateThread(NULL, 0, &run_main_do, (void*) &ThreadData[j], 0, NULL)) == NULL)
				{
					printf("Could not Create Thread\n");
					return(-1);
				}
				/*if ((ThreadData[j].handle = (void*) _beginthreadex(NULL, 0, &run_main_do, (void*) &ThreadData[j], 0, NULL)) == NULL)
				{
					printf("Could not Create Thread\n");
					return(-1);
				}*/
			}
		}

		if ((j = run_main_do(&ThreadData[0])) != 0)
		{
			return(j);
		}

		if (dwThreads > 1)
		{
			printf("Waiting for Threads to terminate\n");
		}
		while (threadsexited < dwThreads - 1)
		{
			SleepEx(10, false);
		}
	}

	for (i = 0;i < GT.CharCount;i++)
	{
		CopyMemory(&Characters[i].Context, &CharContexts[0], sizeof(clsChar::clsCharContext));
	}

	freel(ThreadData);

	if (GT.CharCount > 1)
	{
		j = 0;
	}
	else
	{
		j = 1;
	}
	if (fConsistenceCheck == false)
	{
		if (GT.CharCount)
		{
			SetConsoleActiveScreenBuffer(Screens[j]);
		}
		DoTable();
	}

	return(j);
}

void run_msgloop(int j)
{
	int i, k;

	do
	{
		i = getch();

		if ((i | 32) == 'a')
		{
			j = max(0, j - 1);
		}
	
		if ((i | 32) == 'd')
		{
			j = min(GT.CharCount, j + 1);
		}

		if ((i | 32) == 'w')
		{
			j = GT.CharCount;
		}

		if ((i | 32) == 's')
		{
			j = 0;
		}

		if (i >= '0' && i < min('9', '0' + GT.CharCount))
		{
			j = i - '0';
		}

		if ((i | 32) == 'x')
		{
			if (GT.CharCount)
			{
				char FileName[270] = "export\\";
				FILE* pExportFile;

				ClearConsole(0);
				SetConsoleActiveScreenBuffer(Screens[0]);
			
				printf("Enter Export Filename! ");

				getFileName(FileName + strlen(FileName), ".exp");
				pExportFile = fopen(FileName, "w+");
				if (pExportFile == NULL)
				{
					printf("Coult not oepn export file!\n");
				}
				else
				{
					SetConsoleActiveScreenBuffer(Screens[0]);

					if (j == 0)
					{
						for (k = 0;k < GT.CharCount;k++)
						{
							DisplayChar(&Characters[k], k + 1, 1, pExportFile);
						}
					}
					else
					{
							DisplayChar(&Characters[j - 1], j, 1, pExportFile);
					}
					fclose(pExportFile);
				}

				DoTable();
				SetConsoleActiveScreenBuffer(Screens[j]);
			}
		}

		if ((i | 32) == 'r')
		{
			if (GT.CharCount)
			{
				if (j == 0)
				{
					ClearConsole(0);
					for (k = 0;k < GT.CharCount;k++)
					{
						ClearConsole(k + 1);
						SetConsoleActiveScreenBuffer(Screens[0]);
						Characters[k].CreationTemplate->Life = -100;
						CreateChar(&Characters[k]);
						TPLeft[k + 1] = Characters[k].TPLeft;
						SetConsoleActiveScreenBuffer(Screens[k + 1]);
						DisplayChar(&Characters[k], k + 1);
					}
					SetConsoleActiveScreenBuffer(Screens[0]);
				}
				else
				{
					ClearConsole(0);
					SetConsoleActiveScreenBuffer(Screens[0]);
					ClearConsole(j);
					Characters[j - 1].CreationTemplate->Life = -100;
					CreateChar(&Characters[j - 1]);
					TPLeft[j] = Characters[j - 1].TPLeft;
					DisplayChar(&Characters[j - 1], j);
					SetConsoleActiveScreenBuffer(Screens[j]);
				}
				DoTable();
			}
		}

		if (i == '+' || i == '-' || i == '*')
		{
			if (j != 0)
			{
				int OldLife;
				OldLife = Characters[j - 1].Life;
				ClearConsole(0);
				ClearConsole(j);
				ChangeChar(&Characters[j - 1], i);
				DisplayChar(&Characters[j - 1], j);
				DoTable();
				TPLeft[j] += Characters[j - 1].Life - OldLife;
				DoConsoleTP(j);
			}
		}

		if ((i | 32) == 'v')
		{
			char savename[257];

			ClearConsole(0);
			SetConsoleActiveScreenBuffer(Screens[0]);
			
			printf("Dateinamen zum speichern angeben! ");

			getFileName(savename, ".rep");

			saverep(savename, true, (j == 0 ? Characters[0].CreationTemplate : Characters[j - 1].CreationTemplate), (j == 0 ? GT.CharCount : 1));
			DoTable();
			SetConsoleActiveScreenBuffer(Screens[j]);
		}

		if ((i | 32) == 't' && j != 0)
		{
			ChangeTP(j);
			DoConsoleTP(j);
		}

		if ((i | 32) == 'n')
		{
			Restart = true;
			i = 'q';
			j = 0;
			ClearConsole(0);
		}
		SetConsoleActiveScreenBuffer(Screens[j]);
	} while ((i | 32) != 'q');
}

int run()
{
	int i, retVal;
	LARGE_INTEGER randinit;

	prepos = (unsigned int*) &CTtmp.re.repos;
	retemp = (unsigned int*) &CTtmp.re.retemp[0];
	*prepos = 0;

	QueryPerformanceCounter(&randinit);
	i = randinit.LowPart;
	srand(i);

	manual2 = manual;

	retVal = run_init();
	if (retVal)
	{
		if (retVal == -1)
		{
			goto AskRestart;
		}
		return(1);
	}

	CreateCharContext();

	retVal = run_worktype();
	if (retVal == -1)
	{

AskRestart:
		printf("[N] Zurck ins Hauptmen\n[Q] Beenden\n");
		while(kbhit()){getch();}
		do
		{
			i = getch();

			if ((i | 32) == 'n')
			{
				Restart = true;
				i = 'q';
				if (worktype != 2 && worktype != 1)
				{
					ClearConsole(-1);
				}
			}
		}
		while ((i | 32) != 'q');

		return(0);
	}
	else if (retVal)
	{
		return(1);
	}

	if (reproduce == 2)
	{
		if (run_reproduce())
		{
			run_cleanup(0, 0);
			Restart = 1;
			return(0);
		}
	}
	else if (run_templates())
	{
		return(1);
	}

	if (run_screenbuffer())
	{
		run_cleanup(0);
		return(1);
	}

	InitPassed = 1;

	IsaacInitDone = false;

	retVal = run_main();

	if (retVal != -1 && fConsistenceCheck == false)
	{
		run_msgloop(retVal);
	}

	run_cleanup();

	return(0);
}
